ladybird/Meta/check-debug-flags.sh
sideshowbarker 15d67f0da2 Meta: Make check-debug-flags.sh runnable in Bash 3.2
This change updates the Meta/check-debug-flags.sh script to avoid an
apparent Bach 3.2 parser bug. Specifically, it takes a comment and some
code of a process substitution and moves it into a separate function.

Otherwise, without this change, trying to run the check-debug-flags.sh
script with Bash 3.2 fails with the following error:

line 39: bad substitution: no closing `)' in <(

...apparently because Bash 3.2 chokes on the comment (and doesn’t choke
if the comment is completely removed).

Relates to https://github.com/LadybirdBrowser/ladybird/issues/283
2024-07-16 09:13:14 -06:00

58 lines
2.1 KiB
Bash
Executable file

#!/usr/bin/env bash
set -eo pipefail
script_path=$(cd -P -- "$(dirname -- "$0")" && pwd -P)
cd "${script_path}/.."
MISSING_FLAGS=n
find_all_source_files () {
# We're in the middle of a pre-commit run, so we should only check the files that have
# actually changed. The reason is that "git ls-files | grep" on the entire repo takes
# about 100ms. That is perfectly fine during a CI run, but becomes noticeable during a
# pre-commit hook. It is unnecessary to check the entire repository on every single
# commit, so we save some time here.
#
# And see https://github.com/LadybirdBrowser/ladybird/issues/283; the reason this is
# pulled out into separate function is, Bash 3.2 apparently has a parser bug which
# makes it choke on the above comment if it's in the process substitution below.
for file in "$@"; do
if [[ ("${file}" =~ \.cpp || "${file}" =~ \.h || "${file}" =~ \.in) ]]; then
echo "$file"
fi
done
}
# Check whether all_the_debug_macros.cmake sets all the flags used in C++ code.
while IFS= read -r FLAG; do
# We intentionally don't check for commented-out lines,
# in order to keep track of false positives.
if ! grep -qF "set(${FLAG} ON)" Meta/CMake/all_the_debug_macros.cmake ; then
echo "'all_the_debug_macros.cmake' is missing ${FLAG}"
MISSING_FLAGS=y
fi
done < <(
if [ "$#" -eq "0" ]; then
git ls-files -- \
'*.cpp' \
'*.h' \
'*.in'
else
find_all_source_files "$@"
fi \
| xargs grep -E '(_DEBUG|DEBUG_)' \
| sed -re 's,^.*[^a-zA-Z0-9_]([a-zA-Z0-9_]*DEBUG[a-zA-Z0-9_]*).*$,\1,' \
| sort -u
)
if [ "n" != "${MISSING_FLAGS}" ] ; then
echo "Some flags are missing for the ALL_THE_DEBUG_MACROS feature."
echo "If you just added a new SOMETHING_DEBUG flag, that's great!"
echo "We want to enable all of these in automated builds, so that the code doesn't rot."
echo "Please add it to Meta/CMake/all_the_debug_macros.cmake"
echo "Or perhaps it's not a debug flag?"
echo "Please also add it to Meta/CMake/all_the_debug_macros.cmake"
exit 1
fi